﻿
var test = require('tape');
var client = require('./login.config.js');
var springboard = require('./../index')(client.domain, client.login, client.password);


// This information needs to be updated to you domain
var validOrder = {
  "id": 100002,
  "orderLinesCount": 1,
  "firstItemId": 100022
}

var invalidOrder = {
  "id": 100000
}


// Unit Tests
test('getOrder valid', function (t) {
  springboard.getOrder(validOrder.id, function (error, data, response) {
    t.equal(error, null);
    t.equal(response.statusCode, 200);
    t.equal(data.id, validOrder.id);
    t.end();
  }); 
});

test('getOrder invalid', function (t) {
  springboard.getOrder(invalidOrder.id, function (error, data, response) {
    t.notEqual(error, null);
    t.equal(data.error, 'not_found');
    t.looseEqual(response, null);
    t.end();
  });
});

test('updateOrder', function (t) {
  var update = {
    "sales_rep": "unit-test"
  };
  springboard.updateOrder(validOrder.id, update, function (error, data, response) {
    t.equal(error, null);
    t.equal(response.statusCode, 200);
    t.end();
  });
});

test('getOrderLines', function (t) {
  springboard.getOrderLines(validOrder.id, function (error, data, response) {
    t.equal(error, null);
    t.equal(response.statusCode, 200);
    t.equal(data.results.length, validOrder.orderLinesCount);
    t.equal(data.results[0].item_id, validOrder.firstItemId);
    t.end();
  });
});